<?php
// 14/10/2015 --> modificacion para agregar modulos
// 10/11/2017 --> modificacion para agregar posiciones del 27 al 34
// 22/05/2018 --> se inserta en tabla de licencias de conexiones de equipos 
// 03/10/2018 --> modificacion para agregar posiciones del 35 al 37
// 12/10/2018 --> modificacion para agregar columnas de ftp desde la licencia
// 17/10/2018 --> Agregar posicion 38 y Maximo de NomPC, VERSION APP,  VERSION WCF y VERSION BD
// 18/12/2018 --> Migracion de mysql a PDO ya que mysql fue removido de la version PHP 7
// 04/01/2019 --> Agregar posicion 39
// 25/06/2019 --> Se agrego IsValidHardDiskSerial($row['AuthProcessorId'], $matTemp[8])  para validar serie processorid + 
// 9/11/2020  --> Se cambio de 30 a 60 dias la fecha de desactivacion del software
// 14/11/2020 --> Se agrego libreria mcrypt_compat debido a que ya no era compatible la anterior desde la version 7.2 mcrypt
// 28/12/2021 --> Se hizo modificacion para sacar la maxima version del app, debido a nuevos codigos de versionamiento 2.1.0.*

//-------------------------------------------------------------------------------------------------
use phpseclib\Crypt\Rijndael;

if (!extension_loaded('mcrypt')) 
{
	require_once '/home2/ziursof1/vendor/autoload.php';
}

function addpadding($string, $blocksize = 32)
{
    $len = strlen($string);
    $pad = $blocksize - ($len % $blocksize);
    $string .= str_repeat(chr($pad), $pad);
    return $string;
}
	 
function strippadding($string)
{
    $slast = ord(substr($string, -1));
    $slastc = chr($slast);
    $pcheck = substr($string, -$slast);
    if(preg_match("/$slastc{".$slast."}/", $string))
    {
        $string = substr($string, 0, strlen($string)-$slast);
        return $string;
    } 
    else 
    {
        return false;
    }
}

function encrypt($string = "")
{
    global $key, $iv;
    return base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, addpadding($string), MCRYPT_MODE_CBC, $iv));
}
	 
function decrypt($string = "")
{
    global $key, $iv;
    $string = base64_decode($string);
	$string = strippadding(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $key, $string, MCRYPT_MODE_CBC, $iv));
    return $string;
}

function IsValidHardDiskSerial($dataStored, $dataNew)
{
   if ($dataStored == $dataNew)
   {
      return true;
   }

   $matTemp1 = explode("|", $dataNew);
   $matTemp2 = explode("|", $dataStored);

   foreach($matTemp2 as $item1)
   {
      foreach($matTemp1 as $item2)
      {
         if ($item1 == $item2)
            return true;
      }

   }

   return false;
}
//-------------------------------------------------------------------------------------------------


// Posiciones de la trama
// 00	ERROR CODE        --> Codigo de error 0 indica exito
// 01	IS APPROVED       --> Si se aprueba la activacion
// 02	KEY CHECK         --> Clave de chequeo
// 03	ENTERPRISE SERIAL --> El numero del serial de la licencia
// 04	ENTERPRISE NAME   --> El nombre de la empresa
// 05	ENTERPRISE TYPE   --> El tipo de la licencia
// 06	ENTERPRISE NUMBER --> El numero de licencias de cliente
// 07	ENTERPRISE SEDE   --> La descripcion de la sede 
// 08	PROCESSOR ID      --> El numero del procesador.
// 09	SERIAL HARD DISK  --> El numero de serie del disco duro. 
// 10	MACHINE NAME      --> El nombre de la mquina que se instalo.
// 11	SUPPORT STARTDATE --> Fecha Soporte Inicio 
// 12	SUPPORT ENDDATE   --> Fecha Soporte Fin
// 13	ENTERPRISE NOMTYPE--> Descripcion del tipo de licencia
// 14	CURRENT DATE      --> Fecha Actual
// 15	CUSTOM_MESSAGE    --> Mensaje personalizado
// 16	MODULE_ADDS       --> Modulos predeterminados que tiene la licencia.
// 17	LOCK_DATE         --> Fecha Bloqueo Programa
// 18	SYSTEM_MSG        --> Para envio del mensaje del error.
// 19	ROOTWCFPATH       --> Raiz donde se encuentra el servicio wcf
// 20	ES COMPRA         --> Si la version es en compra
// 21	ES ARRIENDO       --> Si la version esta en arriendo
// 22	ES NUBE           --> Si la version se encuentra en la nube
// 23	LEASE INI         --> Es la fecha de inicio del arriendo
// 24	LEASE FIN         --> Es la fecha de fin del arriendo
// 25	UI TYPE           --> Tipo de interface 0 : Win, 1 : Web
// 26   IS ACTIVE         --> Indica si la licencia esta activa o no   
// Nueva Version 10/11/2017
// 27   NOM EQUIPO        --> Nombre del equipo donde se conecta
// 28   VERSION APP       --> Version de la aplicacion (win form)
// 29   VERSION WCF       --> Version del wcf
// 30   VERSION BD        --> Version de la base de datos (script)
// 31   NOM BASE DATOS    --> Nombre de la base de datos
// 32   FTP SITIOS        --> Sitio(s) ftp donde se guarda el backup
// 33   FTP USUARIOS      --> Usuarios(s) ftp donde se guarda el backup
// 34   FTP CLAVES        --> Claves(s) ftp donde se guarda el backup
// Nueva Version 03/10/2018
// 35   ES FACTURACION EL --> Si la version tiene facturacion electronica
// 36   BACKUP ULTIMO     --> Fecha ultimo backup 
// 37   BACKUP BASE DATOS --> Nombre bases de datos con ultimo backup
// 38   LastAppOk         --> Ultima version valida para la licencia
// 39   FechaDesactivacion--> Ultima version valida para la licencia



// Codigos de Error
//  0 --> Exito
// -1 --> Licencia vacia
// -2 --> Licencia no existe
// -3 --> El codigo de verificacion no coincide

function GetActivation($data)
{
   global $keyCodeCheck;
   
   global $ftpServer_01;
   global $ftpUser_01;
   global $ftpPWD_01;
   
   global $ftpServer_02;
   global $ftpUser_02;
   global $ftpPWD_02;
   
   global $ftpServer_03;
   global $ftpUser_03;
   global $ftpPWD_03;

   global $ftpServer_04;
   global $ftpUser_04;
   global $ftpPWD_04;

   global $ftpServer_05;
   global $ftpUser_05;
   global $ftpPWD_05;
   
   $codError = '0';
   $numPosTrama = 35;

   $cadena = decrypt($data);
   $matTemp = explode(",", $cadena);
   
   //Se hace para incluir nuevas variables de la 20 a la 25
   //--
   $matTemp[20] = "0";
   if (count($matTemp)<=21)
   {
      array_push($matTemp, "0","0","","","0","0");
   }
   //--


   //Se rellena con el numero de posiciones que falten
   //--
   $dif = $numPosTrama - count($matTemp);

   if ($dif > 0)
   {
      $matTemp = array_pad($matTemp, $dif, '');
   }
   //--

   $matTemp[0]='0';
   $matTemp[1]='0';
   
   //Recuperar los valores de la matriz
   //--
   $lic = $matTemp[3];
   //--

   //Si la licencia esta vacia arroja una seal de error
   //--
   if ($lic == '')
   {
      $matTemp[0] = '-1';
      $matTemp[18] = 'Licencia vacia';
      
      return encrypt(implode(",", $matTemp));
   }
   //--

   //Verificar si el codigo de verificacion esta ok
   //--
   if ($matTemp[2] != $keyCodeCheck)
   {
      $matTemp[0] = '-3';
      $matTemp[18] = 'El codigo de chequeo esta erroneo.';

      return encrypt(implode(",", $matTemp));
   }
   //--

   $link = Conectarse();

   $strSql = "SELECT a.IdLicencia, a.NomEmpresa, a.NomSede, a.IdTipo, b.NomTipo, a.NumLic, a.EsActivo, a.AuthProcessorId, a.AuthSerialHD, a.AuthMachineName, a.AuthNomRootWCF, date_format(a.FechaSoporteIni,'%d/%m/%Y') as FechaSopIni, date_format(a.FechaSoporteFin,'%d/%m/%Y') as FechaSopFin, date_format(CURDATE(),'%d/%m/%Y') as FechaActual, a.EsLicenciado, a.EsAprobado, a.Mensaje, date_format(a.FechaBloqueo,'%d/%m/%Y') as FechaBloqueo, a.EsAnulado, a.EsCompra, a.EsArriendo, a.EsNube, date_format(a.FechaArriendoIni,'%d/%m/%Y') as FechaArrIni, date_format(a.FechaArriendoFin,'%d/%m/%Y') as FechaArrFin, a.TipoInterface, aArr.SumLic as LicAdd, CONCAT(b.IdRoles, '|', COALESCE(a.IdRolesAdd,''), ';', COALESCE(a.IdInterfacesAdd,'')) as AllModules, a.EsFactElectronica, date_format(a.BackupUltimo,'%d/%m/%Y') as FechaBackupUltimo, a.BackupBaseDatos, a.FechaSoporteFin, date_format(a.FechaDesactivacion,'%d/%m/%Y') as FechaDesactivacion, a.IdBackupNube " .
             "FROM (Licencias AS a INNER JOIN Licencias_Tipos AS b ON a.IdTipo = b.IdTipo) LEFT JOIN Licencias_ArriendosMax AS aArr ON a.IdLicencia = aArr.IdLicencia " .
             "WHERE a.IdLicencia = '$lic'";

    $qRec =$link->query($strSql) or die($link->errorInfo());
    $row =$qRec->fetch(PDO::FETCH_ASSOC);
	$numRows=$qRec->rowCount();

   if ($numRows==0)
   {
      $matTemp[0] = '-2';
      $matTemp[18] = 'La licencia no existe.';

      return encrypt(implode(",", $matTemp));
   }

   //Actualiza la ultima vez que se conecto por internet con servidor de ziur software
   //--
   $strSql = "UPDATE Licencias SET FechaIngreso = NOW() WHERE IdLicencia =  '$lic'";
   $res =$link->query($strSql);

   if (!$res) 
   { 
        $matTemp[18] = $link->errorInfo()[2];
   }
   //--

   //Inserta la informacion de los equipos que se conectan a ziur software
   //--
   $strSql = "delete from Licencias_ConexionesPorEquipos " . 
             "where IdLicencia = '$lic' and NomEquipo = '$matTemp[27]' and VersionApp = '$matTemp[28]' and VersionWcf = '$matTemp[29]' and VersionBD = '$matTemp[30]' and NomBaseDatos = '$matTemp[31]'";
   $res = $link->query($strSql);

   $strSql= "insert into  Licencias_ConexionesPorEquipos (IdLicencia, NomEquipo, VersionApp, VersionWcf, VersionBD, NomBaseDatos, FechaConexion) " . 
             "values ('$lic', '$matTemp[27]','$matTemp[28]','$matTemp[29]', '$matTemp[30]', '$matTemp[31]', now())";
   $res = $link->query($strSql);
   //--	   

   $tempClaves = "Licencia:" . $lic . " " .
                    "Empresa:" .     $matTemp[4]  . " " .
                    "AuthProcessorId1:" . $row['AuthProcessorId']  . " " .
                    "AuthProcessorId2:" . $matTemp[8]  . " " .
                    "AuthSerialHD1:" . $row['AuthSerialHD']  . " " .
                    "AuthSerialHD2:" . $matTemp[9]  . " " .
                    "AuthMachineName1:" . $row['AuthMachineName']  . " " .
                    "AuthMachineName2:" . $matTemp[10]  . " " .
                    "AuthNomRootWCF1:" . $row['AuthNomRootWCF']  . " " .
                    "AuthNomRootWCF2:" . $matTemp[19];

   //Si la licencia ya se activo se verifica que las claves de autenticacion coincidan
   //--
   if (($matTemp[1] == '0') && ($row['EsLicenciado']==1))
   {  
      //si esta vacia es una version anterior del registro de ziur software
      //--
      if ($matTemp[19] == '')
      {
         $matTemp[19] = $row['AuthNomRootWCF'];
      }
      //--

      //actualiza con la ultima version del registro con el rootwcf
      if ($matTemp[19] != '' && $row['AuthNomRootWCF']=='')
      {
         $strSql = "UPDATE Licencias SET AuthNomRootWCF = '$matTemp[19]' WHERE IdLicencia = '$lic'";
         $res = $link->query($strSql);
      
         if (!$res)
         {
            $matTemp[18] = $link->errorInfo()[2]; 
         }
      }
      //--


      //Se verifica que todos los valores coincidan
      if (
            IsValidHardDiskSerial($row['AuthProcessorId'], $matTemp[8]) && 
            IsValidHardDiskSerial($row['AuthSerialHD'], $matTemp[9]) && 
            $row['AuthMachineName']==$matTemp[10] && 
            strtolower($row['AuthNomRootWCF'])==strtolower($matTemp[19])
         )
      {
         $matTemp[1] = '1';
      }
      elseif (strtolower($row['AuthMachineName'])!=strtolower($matTemp[10]))
      {
         $matTemp[18] = $matTemp[18] . "Cambio el nombre al equipo servidor restaure nombre original '" .  $row['AuthMachineName'] . "'";
         error_log("serial no coinciden claves ..." . $tempClaves  , 0);
      } 
      else
      {
         error_log("serial no coinciden claves ..." . $tempClaves  , 0);
      }
   }
   //--

   //Si hay una aprobacion pendiente es que se decidio hacer un traslado del servidor y se realizo la aprobacion
   //--
   if (($matTemp[1] == '0') && ($row['EsAprobado']==1))
   {
      $matTemp[1] = '1';
      
      //--Actualizar la info nueva de licencia con la info de autenticacion nueva
      //--
      $strSql = "UPDATE Licencias SET EsAprobado = 0, EsLicenciado = 1, FechaActivacion = CURDATE(), AuthProcessorId = :Processor, AuthSerialHD = :SerialHD, AuthMachineName = :MachineName, AuthNomRootWCF = :AuthNom " .
                "WHERE IdLicencia = :id ";

      $res=$link->prepare($strSql);
      $result=$res->execute(array(':id' => $lic,':Processor'=>$matTemp[8],':SerialHD'=>$matTemp[9],':MachineName'=>$matTemp[10],':AuthNom'=>$matTemp[19]));
      if (!$result)
      {
         $matTemp[18] = $res->errorInfo()[2];
      }

      $strSql = "INSERT INTO Licencias_ActivacionLogs (IdLicencia, AuthProcessorId , AuthSerialHD, AuthMachineName, AuthNomRootWCF, FechaActivacion) VALUES (:id, :Processor, :SerialHD, :MachineName, :AuthNom, NOW() ) ";
      $res=$link->prepare($strSql);
      $result=$res->execute(array(':id' => $lic,':Processor'=>$matTemp[8],':SerialHD'=>$matTemp[9],':MachineName'=>$matTemp[10],':AuthNom'=>$matTemp[19]));
      if (!$result)
      {
         $matTemp[18] = $res->errorInfo()[2];
      }
   }
   
   //--
    $soporteFin=$row['FechaSoporteFin'];
   //Maxima version permitida para la licencia actual
   // --
   $strSql = "SELECT VersionToValue(MAX(VersionToString(NomPub))) as NomPubMax " .
             "FROM Publicaciones " .
             "WHERE FechaPub <= '$soporteFin' and IdTipo IN(-1,1) and EsActivo = 1 and IdTipoDeploy = 1 ";

   $qRec =$link->query($strSql) or die($link->errorInfo());
   $rowLast = $qRec->fetch(PDO::FETCH_ASSOC);
   // --

   //Maximo de Version actual, WCF,BD, y Nombre de Equipo
   // --
   $strSql = "SELECT VersionToValue(MAX(VersionToString(VersionApp))) as VersionApp, VersionToValue(MAX(VersionToString(VersionWcf))) as VersionWcf, MAX(VersionBD) as VersionBD, MAX(NomEquipo) as NomEquipo " .
             "FROM Licencias_ConexionesPorEquipos " .
             "WHERE idlicencia='$lic' AND " .
             "VersionApp in ( SELECT VersionToValue(MAX(VersionToString(VersionApp))) FROM Licencias_ConexionesPorEquipos WHERE idlicencia='$lic')";

   $qRec = $link->query($strSql) or die($link->errorInfo());
   $rowMamixo = $qRec->fetch(PDO::FETCH_ASSOC);
   //--


   //Se agregan las licencias que se encuentran en arriendo mas las normales
   // --
   $numTotLic = $row['NumLic'];
   if ($row["LicAdd"] != null)
   {
      $numTotLic = $numTotLic + $row["LicAdd"];
   }
   // --

    //Actualizar fecha de desactivacion por version
   // --
   $DateVersionEnd=$row["FechaDesactivacion"];

  if(version_compare($rowMamixo['VersionApp'], $rowLast['NomPubMax'], '>'))
   {
	   if ($row["FechaDesactivacion"] == null)
	   {
		  //--Actualizar fecha de desactivacion
		  //--
		  $strSql = "UPDATE Licencias SET FechaDesactivacion = NOW() + INTERVAL 60 DAY " .
					"WHERE IdLicencia = :id ";

		  $res=$link->prepare($strSql);
		  $result=$res->execute(array(':id' => $lic));
		  if (!$result)
		  {
             $matTemp[18] = $res->errorInfo()[2];
		  }

		  //--Consultar nuevo valor
		   $strSql = "SELECT date_format(FechaDesactivacion,'%d/%m/%Y') as FechaDesactivacion " .
                     "FROM Licencias " .
                     "WHERE idlicencia='$lic'";

		    $qRec = $link->query($strSql) or die($link->errorInfo());
			$rowtemp = $qRec->fetch(PDO::FETCH_ASSOC);
		    $DateVersionEnd=$rowtemp["FechaDesactivacion"];
	   }
  }
   else{
	   if ($row["FechaDesactivacion"]!= null)
	   {
	      $strSql = "UPDATE Licencias SET FechaDesactivacion = null " .
					"WHERE IdLicencia = :id ";

		  $res=$link->prepare($strSql);
		  $result=$res->execute(array(':id' => $lic));
		  if (!$result)
		  {
			 $matTemp[18] = $res->errorInfo()[2];
		  }

		  $DateVersionEnd=null;
	   }
   }

   // --

   $matTemp[4] = $row['NomEmpresa'];
   $matTemp[5] = $row['IdTipo'];
   $matTemp[6]  = $numTotLic;
   $matTemp[7] = $row['NomSede'];
   
   $matTemp[11] = $row['FechaSopIni'];
   $matTemp[12] = $row['FechaSopFin'];
   $matTemp[13] = $row['NomTipo'];
   $matTemp[14] = $row['FechaActual'];
   $matTemp[15] = $row['Mensaje'];
   $matTemp[16] = $row['AllModules'];

   $matTemp[20] = $row['EsCompra'];
   $matTemp[21] = $row['EsArriendo'];
   $matTemp[22] = $row['EsNube'];
   $matTemp[23] = $row['FechaArrIni'];
   $matTemp[24] = $row['FechaArrFin'];
   $matTemp[25] = $row['TipoInterface'];

   $matTemp[27] = $rowMamixo['NomEquipo'];
   $matTemp[28] = $rowMamixo['VersionApp'];
   $matTemp[29] = $rowMamixo['VersionWcf'];
   $matTemp[30] = $rowMamixo['VersionBD'];


   $strTempServers = $ftpServer_01;
   $strTempUsers = $ftpUser_01;
   $strTempPasswords = $ftpPWD_01;
   
   $tIdBackupNube = $row['IdBackupNube'];
   
   //Si esta vacio le asigna un servidor de forma aleatoria
   //********************
   if ($tIdBackupNube=='')
   {
	   $tIdBackupNube = random_int(3, 5);
	   
	   //Actualiza la el servidor de backup en caso de que venga vacio o nulo
       //--
       $strSql = "UPDATE Licencias SET IdBackupNube = $tIdBackupNube WHERE IdLicencia =  '$lic'";
       $res =$link->query($strSql);

	   if (!$res) 
	   { 
			$matTemp[18] = $link->errorInfo()[2];
	   }
	   
	   error_log("se actualiza el servidor de backup : " . $lic  , 0);
	   
   }
   //*******************


   if ($tIdBackupNube==3)
   {
	   $strTempServers = $ftpServer_03;
	   $strTempUsers = $ftpUser_03;
	   $strTempPasswords = $ftpPWD_03;
   }

   if ($tIdBackupNube==4)
   {
	   $strTempServers = $ftpServer_04;
	   $strTempUsers = $ftpUser_04;
	   $strTempPasswords = $ftpPWD_04;
   }

   if ($tIdBackupNube==5)
   {
	   $strTempServers = $ftpServer_05;
	   $strTempUsers = $ftpUser_05;
	   $strTempPasswords = $ftpPWD_05;
   }
   
   $strTempServers = $strTempServers . "(FTP)" . $ftpServer_02 . "(FTP)";
   $strTempUsers = $strTempUsers . "(U)" . $ftpUser_02 . "(U)";
   $strTempPasswords = $strTempPasswords . "(P)" . $ftpPWD_02 . "(P)";

// error_log("servers:" . $strTempServers);
// error_log("users:" . $strTempUsers);
// error_log("paswords:" . $strTempPasswords);
     
   $matTemp[32] = $strTempServers;
   $matTemp[33] = $strTempUsers;
   $matTemp[34] = $strTempPasswords;

   $matTemp[35] = $row['EsFactElectronica'];
   $matTemp[36] = $row['FechaBackupUltimo'];
   $matTemp[37] = $row['BackupBaseDatos'];

   $matTemp[38] = $rowLast['NomPubMax'];
   $matTemp[39] = $DateVersionEnd;


   // Llenar la variable de EsActivo item 26
   // Causales para que una licencia no este activa
   // Licencia No Activa EsActivo = 0
   // Licencia Anulada EsAnulada = 1
   // Verificar si claves coinicidan
   // Licencia en arriendo que se encuentra vencida
   

   //--
   $matTemp[26] = '1';

   //Verificar si la licencia esta Activa
   if (($matTemp[26] == '1') && ($row['EsActivo']==0))
   {
      $matTemp[26] = '0';
      $matTemp[18] = $matTemp[18] . ' ' . 'Licencia No Activa';
   }

   //Verificar si licencia esta Anulada
   if (($matTemp[26] == '1') && ($row['EsAnulado']==1))
   {
      $matTemp[26] = '0';
      $matTemp[18] = $matTemp[18] . ' ' . 'Licencia Anulada';
   }
   //--

   if ($matTemp[1]=='0')
   {
      $matTemp[18] = $matTemp[18] . ' ' . 'No se puede activar el servidor debido a que no coinciden las claves de autenticacin.';
   }

 //Liberar recursos
   //--
   $qRec->closeCursor();
   $link=null;
   //--

   return encrypt(implode(",", $matTemp));
}

?>