<?php
// 14/10/2015 --> modificacion para agregar modulos

//-------------------------------------------------------------------------------------------------
function addpadding($string, $blocksize = 32)
{
    $len = strlen($string);
    $pad = $blocksize - ($len % $blocksize);
    $string .= str_repeat(chr($pad), $pad);
    return $string;
}
	 
function strippadding($string)
{
    $slast = ord(substr($string, -1));
    $slastc = chr($slast);
    $pcheck = substr($string, -$slast);
    if(preg_match("/$slastc{".$slast."}/", $string))
    {
        $string = substr($string, 0, strlen($string)-$slast);
        return $string;
    } 
    else 
    {
        return false;
    }
}

function encrypt($string = "")
{
    global $key, $iv;
    return base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, addpadding($string), MCRYPT_MODE_CBC, $iv));
}
	 
function decrypt($string = "")
{
    global $key, $iv;
    $string = base64_decode($string);
    return strippadding(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $key, $string, MCRYPT_MODE_CBC, $iv));
}

function IsValidHardDiskSerial($dataStored, $dataNew)
{
   if ($dataStored == $dataNew)
   {
      return true;
   }

   $matTemp1 = explode("|", $dataNew);
   $matTemp2 = explode("|", $dataStored);

   foreach($matTemp2 as $item)
   {
      if ($item == $matTemp1[0])
         return true;
   }

   return false;
}
//-------------------------------------------------------------------------------------------------


// Posiciones de la trama
// 0	ERROR CODE        --> Codigo de error 0 indica exito
// 1	IS APPROVED       --> Si se aprueba la activacion
// 2	KEY CHECK         --> Clave de chequeo
// 3	ENTERPRISE SERIAL --> El numero del serial de la licencia
// 4	ENTERPRISE NAME   --> El nombre de la empresa
// 5	ENTERPRISE TYPE   --> El tipo de la licencia
// 6	ENTERPRISE NUMBER --> El numero de licencias de cliente
// 7	ENTERPRISE SEDE   --> La descripcion de la sede 
// 8	PROCESSOR ID      --> El numero del procesador.
// 9	SERIAL HARD DISK  --> El numero de serie del disco duro. 
// 10	MACHINE NAME      --> El nombre de la mquina que se instalo.
// 11	SUPPORT STARTDATE --> Fecha Soporte Inicio 
// 12	SUPPORT ENDDATE   --> Fecha Soporte Fin
// 13	ENTERPRISE NOMTYPE--> Descripcion del tipo de licencia
// 14	CURRENT DATE      --> Fecha Actual
// 15	CUSTOM_MESSAGE    --> Mensaje personalizado
// 16	MODULE_ADDS       --> Modulos predeterminados que tiene la licencia.
// 17	LOCK_DATE         --> Fecha Bloqueo Programa
// 18	SYSTEM_MSG        --> Para envio del mensaje del error.
// 19	ROOTWCFPATH       --> Raiz donde se encuentra el servicio wcf
// 20	ES COMPRA         --> Si la version es en compra
// 21	ES ARRIENDO       --> Si la version esta en arriendo
// 22	ES NUBE           --> Si la version se encuentra en la nube
// 23	LEASE INI         --> Es la fecha de inicio del arriendo
// 24	LEASE FIN         --> Es la fecha de fin del arriendo
// 25	UI TYPE           --> Tipo de interface 0 : Win, 1 : Web
// 26   IS ACTIVE         --> Indica si la licencia esta activa o no   


// Codigos de Error
//  0 --> Exito
// -1 --> Licencia vacia
// -2 --> Licencia no existe
// -3 --> El codigo de verificacion no coincide

function GetActivation($data)
{
   global $keyCodeCheck;

   $codError = '0';

   $cadena = decrypt($data);
   $matTemp = explode(",", $cadena);

   //Se hace para incluir nuevas variables de la 20 a la 25
   //--
   $matTemp[20] = "0";
   if (count($matTemp)<=21)
   {
      array_push($matTemp, "0","0","","","0","0");
   }

   //--

   $matTemp[0]='0';
   $matTemp[1]='0';
   
   //Recuperar los valores de la matriz
   //--
   $lic = $matTemp[3];
   //--

   //Si la licencia esta vacia arroja una seal de error
   //--
   if ($lic == '')
   {
      $matTemp[0] = '-1';
      $matTemp[18] = 'Licencia vacia';
      
      return encrypt(implode(",", $matTemp));
   }
   //--

   //Verificar si el codigo de verificacion esta ok
   //--
   if ($matTemp[2] != $keyCodeCheck)
   {
      $matTemp[0] = '-3';
      $matTemp[18] = 'El codigo de chequeo esta erroneo.';

      return encrypt(implode(",", $matTemp));
   }
   //--

   $link = Conectarse();

   $strSql = "SELECT a.IdLicencia, a.NomEmpresa, a.NomSede, a.IdTipo, b.NomTipo, a.NumLic, a.EsActivo, a.AuthProcessorId, a.AuthSerialHD, a.AuthMachineName, a.AuthNomRootWCF, date_format(a.FechaSoporteIni,'%d/%m/%Y') as FechaSopIni, date_format(a.FechaSoporteFin,'%d/%m/%Y') as FechaSopFin, date_format(CURDATE(),'%d/%m/%Y') as FechaActual, a.EsLicenciado, a.EsAprobado, a.Mensaje, date_format(a.FechaBloqueo,'%d/%m/%Y') as FechaBloqueo, a.EsAnulado, a.EsCompra, a.EsArriendo, a.EsNube, date_format(a.FechaArriendoIni,'%d/%m/%Y') as FechaArrIni, date_format(a.FechaArriendoFin,'%d/%m/%Y') as FechaArrFin, a.TipoInterface, aArr.SumLic as LicAdd, CONCAT(b.IdRoles, '|', COALESCE(a.IdRolesAdd,''), ';', COALESCE(a.IdInterfacesAdd,'')) as AllModules " .
             "FROM (Licencias AS a INNER JOIN Licencias_Tipos AS b ON a.IdTipo = b.IdTipo) LEFT JOIN Licencias_ArriendosMax AS aArr ON a.IdLicencia = aArr.IdLicencia " .
             "WHERE a.IdLicencia = '$lic'";


   	$qRec =$link->query($strSql) or die($link->errorInfo());
    $row =$qRec->fetch(PDO::FETCH_ASSOC);
	$numRows=$qRec->rowCount();

   if ($numRows==0)
   {
      $matTemp[0] = '-2';
      $matTemp[18] = 'La licencia no existe.';

      return encrypt(implode(",", $matTemp));
   }

   //Actualiza la ultima vez que se conecto por internet con servidor de ziur software
   //--
   $strSql = "UPDATE Licencias SET FechaIngreso = NOW() WHERE IdLicencia = '$lic'";
   $res =$link->query($strSql);
      
   if (!$res)
   {
      $matTemp[18] = $link->errorInfo()[2];
   }
   //--

   //Si la licencia ya se activo se verifica que las claves de autenticacion coincidan
   //--
   if (($matTemp[1] == '0') && ($row['EsLicenciado']==1))
   {  
      //si esta vacia es una version anterior del registro de ziur software
      //--
      if ($matTemp[19] == '')
      {
         $matTemp[19] = $row['AuthNomRootWCF'];
      }
      //--

      //actualiza con la ultima version del registro con el rootwcf
      if ($matTemp[19] != '' && $row['AuthNomRootWCF']=='')
      {
         $strSql = "UPDATE Licencias SET AuthNomRootWCF = '$matTemp[19]' WHERE IdLicencia = '$lic'";
         $res = $link->query($strSql);
      
         if (!$res)
         {
            $matTemp[18] = $link->errorInfo()[2]; 
         }
      }
      //--


      //Se verifica que todos los valores coincidan
      //if ($row['AuthProcessorId']==$matTemp[8] && $row['AuthSerialHD']==$matTemp[9] && $row['AuthMachineName']==$matTemp[10] && strtolower($row['AuthNomRootWCF'])==strtolower($matTemp[19]))
      if ($row['AuthProcessorId']==$matTemp[8] && IsValidHardDiskSerial($row['AuthSerialHD'], $matTemp[9]) && $row['AuthMachineName']==$matTemp[10] && strtolower($row['AuthNomRootWCF'])==strtolower($matTemp[19]))
      {
         $matTemp[1] = '1';
      }
   }
   //--

   //Si hay una aprobacion pendiente es que se decidio hacer un traslado del servidor y se realizo la aprobacion
   //--
   if (($matTemp[1] == '0') && ($row['EsAprobado']==1))
   {
      $matTemp[1] = '1';
      
      //--Actualizar la info nueva de licencia con la info de autenticacion nueva
      //--
      $strSql = "UPDATE Licencias SET EsAprobado = 0, EsLicenciado = 1, FechaActivacion = CURDATE(), AuthProcessorId = '$matTemp[8]', AuthSerialHD = '$matTemp[9]', AuthMachineName = '$matTemp[10]', AuthNomRootWCF = '$matTemp[19]' " .
                "WHERE IdLicencia = '$lic'";

     $res =$link->query($strSql);
      
      if (!$res)
      {
         $matTemp[18] =  $link->errorInfo()[2]; 
         //die('Invalid query: ' . mysql_error());
      }

      $strSql = "INSERT INTO Licencias_ActivacionLogs (IdLicencia, AuthProcessorId , AuthSerialHD, AuthMachineName, AuthNomRootWCF, FechaActivacion) VALUES ('$lic', '$matTemp[8]', '$matTemp[9]', '$matTemp[10]', '$matTemp[19]', NOW() )  ";
      $res =$res =$link->query($strSql);
      if (!$res)
      {
         $matTemp[18] =  $link->errorInfo()[2]; 
         //die('Invalid query: ' . mysql_error());
      }
   }
   //--

   //Se agregan las licencias que se encuentran en arriendo mas las normales
   // --
   $numTotLic = $row['NumLic'];
   if ($row["LicAdd"] != null)
   {
      $numTotLic = $numTotLic + $row["LicAdd"];
   }
   // --

   $matTemp[4] = $row['NomEmpresa'];
   $matTemp[5] = $row['IdTipo'];
   $matTemp[6]  = $numTotLic;
   $matTemp[7] = $row['NomSede'];
   
   $matTemp[11] = $row['FechaSopIni'];
   $matTemp[12] = $row['FechaSopFin'];
   $matTemp[13] = $row['NomTipo'];
   $matTemp[14] = $row['FechaActual'];
   $matTemp[15] = $row['Mensaje'];
   $matTemp[16] = $row['AllModules'];

   $matTemp[20] = $row['EsCompra'];
   $matTemp[21] = $row['EsArriendo'];
   $matTemp[22] = $row['EsNube'];
   $matTemp[23] = $row['FechaArrIni'];
   $matTemp[24] = $row['FechaArrFin'];
   $matTemp[25] = $row['TipoInterface'];

   // Llenar la variable de EsActivo item 26
   // Causales para que una licencia no este activa
   // Licencia No Activa EsActivo = 0
   // Licencia Anulada EsAnulada = 1
   // Verificar si claves coinicidan
   // Licencia en arriendo que se encuentra vencida
   

   //--
   $matTemp[26] = '1';

   //Verificar si la licencia esta Activa
   if (($matTemp[26] == '1') && ($row['EsActivo']==0))
   {
      $matTemp[26] = '0';
      $matTemp[18] = $matTemp[18] . ' ' . 'Licencia No Activa';
   }

   //Verificar si licencia esta Anulada
   if (($matTemp[26] == '1') && ($row['EsAnulado']==1))
   {
      $matTemp[26] = '0';
      $matTemp[18] = $matTemp[18] . ' ' . 'Licencia Anulada';
   }
   //--

   if ($matTemp[1]=='0')
   {
      $matTemp[18] = $matTemp[18] . ' ' . 'No se puede activar el servidor debido a que no coinciden las claves de autenticacin.';
   }

   //Liberar recursos
   //--
   $qRec->closeCursor();
   $res->closeCursor();
   $link=null;
   //--

   return encrypt(implode(",", $matTemp));
}

?>